unit unDLL;

interface

uses
  Windows, Messages, SysUtils,
  {$IFDEF VER150} Variants,{$ENDIF}
  Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TfmDLL = class(TForm)
    pnDLL: TPanel;
    btClear: TButton;
    Edit1: TEdit;
    procedure btClearClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function InitLib(App: Integer): Boolean; register; exports InitLib;
function CreateFM(): Boolean; register; exports CreateFM;
function ShowPN(pn: HWND): Pointer; register; exports ShowPN;
function HidePN(): Boolean; register; exports HidePN;
function ReleaseFM(): Boolean; register; exports ReleaseFM;
function UnloadLib(): Boolean; register; exports UnloadLib;


var
  fmDLL: TfmDLL;
  DLLApp: TApplication;

implementation

{$R *.dfm}

function InitLib(App: Integer): Boolean;
begin
 DLLApp      :=Application;
 Application :=TApplication(App);
 Result      :=True;
end;

function CreateFM(): Boolean;
begin
 Application.CreateForm(TfmDLL, fmDLL);
 fmDLL.Show;
 Result:=True;
end;

function ShowPN(pn: HWND): Pointer;
begin
 //ShowMessage(fmDLL.pnDLL.Parent.Name);
 fmDLL.pnDLL.Parent:=nil;
 fmDLL.pnDLL.ParentWindow:=pn;
 //ShowMessage(fmDLL.pnDLL.Parent.Name); // and it shows right OWNER.Name but doesnt show it ;( !!!
 Result:=fmDLL.pnDLL;
end;

function HidePN(): Boolean;
begin
 fmDLL.pnDLL.Parent:=nil;
 fmDLL.pnDLL.ParentWindow:=fmDLL.Handle;
 fmDLL.pnDLL.Parent:=fmDLL;
 Result:=True;
end;

function ReleaseFM(): Boolean;
begin
 fmDLL.Free;
 Result:=True;
end;

function UnloadLib(): Boolean;
begin
 Application :=DLLApp;
 Result      :=True;
end;

procedure TfmDLL.btClearClick(Sender: TObject);
begin
 Edit1.Text:='';
end;

end.
